﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace jamProject
{
    public class Bolls
    {
        public Texture2D txt;
        public Rectangle rame,rameBonus;
        public Vector2 pos,origin, size, velocity;

        public Color clr;

        public float clrF = 0;
        float depth;
        float speed;
        public bool newBolls, newBonus;

        public int modeForPl= -1;

        MouseState mStatePast;

        public Bolls(Texture2D txt, Vector2 pos, Vector2 velocity, Vector2 size)
        {
            Random r = new Random();

            this.txt = txt;

            if (pos == Vector2.Zero)
                this.pos = new Vector2(1400, new Random().Next((int)(768 * 1.5f)));
            else this.pos = pos;

            rame = new Rectangle(0, 0, 64, 64);


            origin = new Vector2(rame.Width / 2f, rame.Height / 2f);
            clr = Color.White;

            if (size == Vector2.Zero)
                this.size = new Vector2(r.Next(5, 30) / 10f);
            else this.size = size;

            if (this.size.X > 1)
                depth = 0.6f;
            else if (this.size.X < 1) depth = 0.4f;

            if (velocity != Vector2.Zero)
                this.velocity = new Vector2(-10, -2) * velocity;
            else this.velocity = new Vector2(-10, -2);

            speed = r.Next(5, 10) / 10f;

            mStatePast = Mouse.GetState();



            if (size.X == 0)
                if (this.size.X >= 0.75f && this.size.X <= 2f)
                {
                    modeForPl = r.Next(4);
                    if (modeForPl >= 1)
                    {
                        rameBonus = rame;
                        rameBonus.Y = 64 * modeForPl;

                    }
                }
        }

        public void Update(Game1 game)
        {
            if (velocity.X < -9.75) velocity.X += 0.1f * game.GameSpeed;
            else if (velocity.X > -10.25f) velocity.X -= 0.1f * game.GameSpeed;
            else velocity.X = -10;

            if (velocity.Y < -2.25f) velocity.Y += 0.1f * game.GameSpeed;
            else if (velocity.Y > -1.75f) velocity.Y -= 0.1f * game.GameSpeed;
            else velocity.Y = -2;

            pos += velocity * speed * game.GameSpeed;

            int x = (int)((pos.X + 32 * size.X) / 10f);
            int y = (int)((pos.Y + 32 * size.X) / 10f);

            if (size.X >= 0.75f)
                for (int y1 = y - 6; y1 <= y; y1++)
                    if (x >= 0 && x < game.xGrid && y1 >= 0 && y1 < game.yGrid)
                        if (game.grid[x, y1] >= 10)
                        {
                            if (modeForPl >= 1)
                                if (game.grid[x, y1] == 10)
                                {
                                    if (game.pl.hp > 0)
                                        game.pl.Score += 1;
                                    game.pl.rotTime = 2;
                                    game.pl.openRot = true;
                                }
                                else
                                {

                                    game.anti[game.grid[x, y1] - 11].Score += 1;
                                    game.anti[game.grid[x, y1] - 11].rotTime = 2;
                                    game.anti[game.grid[x, y1] - 11].openRot = true;
                                }

                            newBolls = true;

                            SoundsPlayer.Play(game, "bulk", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x * 10, y1 * 10));

                            if (modeForPl == 1) SoundsPlayer.Play(game, "butilka", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x * 10, y1 * 10), 5, 0.25f);
                            if (modeForPl == 2) SoundsPlayer.Play(game, "syharik", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x * 10, y1 * 10), 5, 0.25f);
                            if (modeForPl == 3) SoundsPlayer.Play(game, "bumaga", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x * 10, y1 * 10), 5, 0.25f);
                        }

            if (size.X >= 0.75f)
                for (int x1 = x - 6; x1 <= x; x1++)
                    if (x1 >= 0 && x1 < game.xGrid && y >= 0 && y < game.yGrid)
                        if (game.grid[x1, y] >= 10)
                        {
                            if (modeForPl >= 1)
                                if (game.grid[x1, y] == 10)
                                {
                                    if (game.pl.hp > 0)
                                        game.pl.Score += 1;
                                    game.pl.rotTime = 2;
                                    game.pl.openRot = true;
                                }
                                else
                                {

                                    game.anti[game.grid[x1, y] - 11].Score += 1;
                                    game.anti[game.grid[x1, y] - 11].rotTime = 2;
                                    game.anti[game.grid[x1, y] - 11].openRot = true;
                                }

                            newBolls = true;

                            SoundsPlayer.Play(game, "bulk", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x1 * 10, y * 10));

                            if (modeForPl == 1) SoundsPlayer.Play(game, "butilka", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x1 * 10, y * 10), 5, 0.25f);
                            if (modeForPl == 2) SoundsPlayer.Play(game, "syharik", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x1 * 10, y * 10), 5, 0.25f);
                            if (modeForPl == 3) SoundsPlayer.Play(game, "bumaga", new Vector2(1366 / 2f, 768 / 2f), new Vector2(x1 * 10, y * 10), 5, 0.25f);
                        }
        }
        public void Draw(Game1 game, SpriteBatch spriteBatch)
        {
            //float clf = size.X;
            //if (clf > 0.7f) clf = 0.7f;

            spriteBatch.Draw(txt, pos, rame, Color.Lerp(Color.White, game.clrBackgr, 0), 0, origin, size, SpriteEffects.None, depth);


            if (modeForPl >= 1)
                spriteBatch.Draw(txt, pos, rameBonus, Color.Lerp(Color.White, game.clrBackgr, 0), 0, origin, size * 0.5f, SpriteEffects.None, depth - 0.01f);
        }
    }
}
