﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace jamProject
{
    public class Fish
    {
        public Texture2D txt, txtClrChange;
        public Rectangle rame, rameEye;
        public Vector2 pos,origin, velocity;
        public float rotation = 0, rotationCursor;

        public Color clr;

        public float clrF = 0, hp = 100, rotTime;
        float jump;

        int y = 0;

        public int iClick, Score;
        float cadr, sizeEye;
        float changeCadr;

        public bool openRot;

        MouseState mStatePast;

        Vector2 startCursor, posM;

        public Color[] clrs = new Color[]
        {
            new Color(139,34,252),
            new Color(255,137,0),
            new Color(222,4,41),
            new Color(48,101,209),
            new Color(3,222,102)
        };

        int oldMode, newMode;

        public Fish(Texture2D txt, Texture2D txtClrChange, Vector2 pos, int y)
        {
            this.txt = txt;
            this.txtClrChange = txtClrChange;
            this.pos = pos;
            //pos = new Vector2(64, 768 / 2f);
            rame = new Rectangle(0, 512 * 0, 256, 256);


            origin = new Vector2(rame.Width / 2f, rame.Height / 2f);
            clr = Color.White;

            rotation = (float)Math.PI - (float)Math.PI / 6 + (float)Math.PI;

            mStatePast = Mouse.GetState();

            this.y = y;

            int r = new Random().Next(5);

            if (y == 0)
            {

                rameEye = rame;
                rameEye.Y = 512;
            }
            else clr = new Color(clrs[r], 200);
        }
        float speed = 0, speed2 = 1;
        public void UpdatePlayer(Game1 game)
        {


            if (speed > 0)
                speed /= 4f;

            //if (iClick > 5)
            {
                speed2 = 1;

                if (iClick > 5) game.Start = true;
            }
            //else speed2 = 0.2f * iClick;

            //startCursor = Vector2.Zero;
            //rotationCursor = 0;
            if (hp > 0)
                if (Mouse.GetState().LeftButton == ButtonState.Pressed && mStatePast.LeftButton != ButtonState.Pressed)
                {
                    //if (pos.X < 1366 / 2f)
                    if (pos.Y > 0)
                        speed = 0.75f * 0.75f;

                    if (game.fClrText >= 1 && iClick < 3)
                    {
                        iClick++;
                        game.fClrText = 0;
                    }
                    else if (iClick >= 3)
                        iClick++;

                    startCursor = new Vector2(Mouse.GetState().X, Mouse.GetState().Y);

                    oldMode = game.modeClr;
                }
                else;
            else if (pos.Y > 40) pos.Y -= 5f;


            if (rotTime > 0)
                rotTime -= 0.05f;
            else openRot = false;

            if (Mouse.GetState().LeftButton == ButtonState.Pressed && Score >= 10 && hp > 0)
            {
                speed2 = 0.5f;

                if (game.GameSpeed > 0.2f)
                    game.GameSpeed -= 0.015f;
                else game.GameSpeed = 0.2f;

                posM = new Vector2(Mouse.GetState().X, Mouse.GetState().Y);
                rotationCursor = (float)Math.Atan2(startCursor.Y - posM.Y, startCursor.X - posM.X);
                openRot = true;

                cadr = 7;
            }
            else
            {
                if (game.GameSpeed < 1)
                    game.GameSpeed += 0.02f;
                else game.GameSpeed = 1;

                if (Score >= 10)
                    if (game.modeClr != oldMode)
                    {
                        Score -= 10;
                        oldMode = game.modeClr;
                    }
            }

            //pos.X += 75 * speed;
            pos.Y -= 75 * speed;

            if (pos.X < 1366 / 2f)
                pos.X += 0.5f;

            //if (pos.X > 150) pos.X -= 3f * speed2 * game.GameSpeed;
            if (pos.Y < 768 - 150) pos.Y += 75 / 37f * speed2 * game.GameSpeed;


            //clr = Color.Lerp(Color.White, Color.Red, clrF);
            mStatePast = Mouse.GetState();

            //if (game.modeClr >= 0)
            //    clr = new Color(game.clrsBackgr[game.modeClr] * 0.9f, 255);
        }

        public void UpdateAnti(Game1 game, GameTime gameTime, int i)
        {
            if (game.Start)
            {
                if (rotTime > 0)
                    rotTime -= 0.05f;
                else openRot = false;

                if (jump > 0)
                    jump -= (float)gameTime.ElapsedGameTime.TotalSeconds * game.GameSpeed;

                if (jump <= 0)
                {
                    pos.X += 1.75f;
                    //pos.Y -= 15;

                    jump = new Random(i).Next(20, 30) / 1600f * game.GameSpeed;
                }
                else if (jump > 0.1f) pos.X -= 1.5f * game.GameSpeed;

                if (hp <= 0)
                    if (pos.Y > 40) pos.Y -= 5f;
            }
        }

        public void DrawChangeClr(Game1 game, SpriteBatch spriteBatch)
        {

            Vector2 pos = this.pos + new Vector2((256 / 2 * 192 / 256f) - 10, -(256 / 2 * 192 / 256f) + 30);



            float s = 1 - game.GameSpeed;
            if (s < 0.65f) s = 0;
            else
            {
                //int m = game.modeClr;

                float r = rotationCursor + (float)Math.PI;
                if (r >= 0 && r < (float)Math.PI / 1.5f / 2f)
                    game.modeClr = 0;
                else if (r < (float)Math.PI / 1.5f / 2f + (float)Math.PI / 1.5f)
                    game.modeClr = 1;
                else if (r < (float)Math.PI / 1.5f / 2f + (float)Math.PI / 1.5f + (float)Math.PI / 1.5f)
                    game.modeClr = 2;
                else game.modeClr = 0;

                //if (m != game.modeClr) Score -= 10;
            }
            //else if (rotationCursor >= (float)Math.PI / 1.5f && )

            for (int i = 0; i < game.clrsBackgr.Count(); i++)
            {
                float size = s * 0.6f;

                if (i == game.modeClr) size *= 1.25f;

                spriteBatch.Draw(txtClrChange, pos, new Rectangle(0, 0, txtClrChange.Width, txtClrChange.Height), game.clrsBackgr[i] * s, (float)Math.PI / 1.5f * i, new Vector2(7, txtClrChange.Height / 2), size, SpriteEffects.None, 0.9f);

            }

            //spriteBatch.Draw(txt, startCursor, new Rectangle(0, 0, 10, 10), Color.White, rotationCursor, new Vector2(5, 5), new Vector2(1, 1), SpriteEffects.None, 0.99f);
            //spriteBatch.Draw(txt, posM, new Rectangle(0, 0, 10, 10), Color.Black, rotationCursor, new Vector2(5, 5), new Vector2(1, 1), SpriteEffects.None, 0.99f);

        }

        public void Draw(Game1 game, GameTime gameTIme, SpriteBatch spriteBatch, float depth)
        {

            //if (hp > 0)
            if (!openRot)
                if (cadr < 12)
                    cadr += 0.75f * game.GameSpeed;
                else cadr = 0;

            rame.X = (int)cadr * 256;


            if (!openRot)
            {
                rame.Y = 0;
                if (sizeEye < 1) sizeEye += 0.1f;
                else sizeEye = 1;

            }
            else
            {
                rame.Y = 256;
                rame.X = 256;

            }

            int cadrEye = (int)cadr;
            if (cadrEye >= 8)
                cadrEye = 7;

            SpriteEffects se = SpriteEffects.None;
            if (hp <= 0)
                se = SpriteEffects.FlipVertically;

            if (Score >= 10)
            {
                rameEye.X = cadrEye * 256;

                //float fr = (cadrEye - 4) / 4f;

                spriteBatch.Draw(txt, pos, rameEye, Color.White, 0, origin, 192 / 256f * sizeEye, se, depth - 0.01f);

            }
            spriteBatch.Draw(txt, pos, rame, clr, 0, origin, 192 / 256f, se, depth);
        }
    }
}
