﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework;

//using System.Windows.Forms;

namespace jamProject
{
    public static class SoundsPlayer //A simple way to be able to type text XNA environment.
    {
        public static List<SoundEffectTest> sound= new List<SoundEffectTest>();

        public static void SoundsPlayerLoad(Game1 game)
        {
            sound.Add(new SoundEffectTest("bulk", game.Content.Load<SoundEffect>("Sounds/bubble1")));
            sound.Add(new SoundEffectTest("bulk", game.Content.Load<SoundEffect>("Sounds/bubble1")));

            sound.Add(new SoundEffectTest("butilka", game.Content.Load<SoundEffect>("Sounds/garbage3")));
            sound.Add(new SoundEffectTest("syharik", game.Content.Load<SoundEffect>("Sounds/garbage1")));
            sound.Add(new SoundEffectTest("bumaga", game.Content.Load<SoundEffect>("Sounds/garbage2")));

        }

        static List<float[]> sS = new List<float[]>();

        public static void SendOnServer(Game1 game, string named, Vector2 posSound, int rPitch = 0, float volumeF = 1)
        {
            {
                Play(game, named, new Vector2(1366 / 2f, 768 / 2f), posSound, rPitch, volumeF);
            }
        }

        public static void Play(Game1 game, string named, Vector2 cameraPos, Vector2 posSound, int rPitch = 0, float volumeF = 1)
        {
            List<int> iS = new List<int>();
            float volume = 0, pitch = new Random().Next(-rPitch, rPitch) / 10f, pan = 0;
            float rast = 683;


            volume = ((rast - (int)Vector2.Distance(new Vector2(cameraPos.X, cameraPos.Y), new Vector2(posSound.X, posSound.Y))) / rast) * volumeF;

            pan = (posSound.X - cameraPos.X) / (rast / 2);
            if (pan < -1) pan = -1;
            else if (pan > 1) pan = 1;

            if (volume > 0)
                for (int i = 0; i < sound.Count(); i++)
                    if (sound[i].named == named)
                        if ((int)Vector2.Distance(new Vector2(cameraPos.X, cameraPos.Y), new Vector2(posSound.X, posSound.Y)) <= rast)
                        {
                            iS.Add(i);
                        }

            if (iS.Count() > 0)
            {
                int i1 = new Random().Next(iS.Count());

                float[] f = new float[4]
                {
                    iS[i1], volume, pitch, pan,
                };

                if (sS.Count() < 6)
                    sS.Add(f);
            }


        }

        public static void PlayAllS(Game1 game, GameTime gameTime)
        {
            {
                int max = sS.Count();
                //if (max > 2) max = 2;

                for (int iss = 0; iss < max; iss++)
                    if (sS.Count() > 0)
                    {
                        float[] i = sS[iss];
                        sound[(int)i[0]].Play(game.allVolume /** 0.5f*/ * i[1], i[2], i[3]);
                        sS.RemoveAt(iss);
                        iss--;
                    }
            }
        }

        public class SoundEffectTest
        {
            public string named;
            SoundEffect sound;
            public SoundEffectTest(string named, SoundEffect sound)
            {
                this.named = named;
                this.sound = sound;
            }
            public void Play(float volume, float pitch, float pan)
            {
                float volume1 = volume;
                if (volume1 > 1) volume1 = 1;
                if (volume1 < 0) volume1 = 0;

                float pitch1 = pitch;
                if (pitch1 > 1) pitch1 = 1;
                else if (pitch1 < -1) pitch1 = -1;

                float pan1 = pan;
                if (pan1 > 1) pan1 = 1;
                if (pan1 < -1) pan1 = -1;

                sound.Play(volume1, pitch1, pan1);
            }

        }
    }
}
