﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace jamProject
{
    public class Wave
    {
        public Texture2D txt;
        public Rectangle rame;
        public Vector2 pos, raznPos,origin, size;
        float rotation = 0;

        public Color clr;

        public float clrF = 0;
        float depth;
        float speed;
        public bool newBolls;

        public float x = -4000;

        float sizeOth, minusOth;

        MouseState mStatePast;

        public int modeClr;

        public Wave(Game1 game, Texture2D txt, int x)
        {
            Random r = new Random();

            this.txt = txt;

            rame = new Rectangle(0, 0, txt.Width, txt.Height);
            pos = new Vector2(-1000, 0);
            this.x = x;

            origin = new Vector2(0, 0);

            size = new Vector2(1);

            rotation = (float)Math.PI - (float)Math.PI / 6;
            clr = Color.White;
            depth = 0.89f;

            modeClr = new Random().Next(game.clrsBackgr.Count());

            while (modeClr == game.modeClr)
                modeClr = new Random().Next(game.clrsBackgr.Count());

        }

        public void Update(Game1 game)
        {
            pos.X += 5 * game.GameSpeed;
            sizeOth += 0.00125f * minusOth * game.GameSpeed;

            if (sizeOth >= 1)
            {
                minusOth = -1;
                sizeOth = 1;
            }
            else if (sizeOth <= 0.75f)
            {
                minusOth = 1;
                sizeOth = 0.75f;
            }

        }
        public void Draw(Game1 game, SpriteBatch spriteBatch)
        {
            if (modeClr >= 0)
                clr = new Color(game.clrsBackgr[modeClr] * 0.9f, 255);

            if (modeClr != game.modeClr)
            {
                spriteBatch.Draw(txt, pos, rame, clr * 0.75f, 0, origin, size, SpriteEffects.None, depth);
                spriteBatch.Draw(txt, pos + new Vector2(-100, 0), rame, clr * 0.75f, 0, origin, new Vector2(size.X * 1.125f * sizeOth * sizeOth, size.Y * 1.5f), SpriteEffects.FlipVertically, depth + 0.01f);
                spriteBatch.Draw(txt, pos + new Vector2(-250, 0), rame, clr * 0.75f, 0, origin, new Vector2(size.X * 1.0525f * sizeOth, size.Y * 1.5f), SpriteEffects.None, depth + 0.02f);
            }
        }
    }
}
